#ifndef __QT_PREPROCESSOR_THREAD_H
#define __QT_PREPROCESSOR_THREAD_H

#ifndef NO_QT
#include <QThread>
#include "PreprocessorThread.h"

namespace GtpVisibilityPreprocessor {

class Preprocessor;

class QtPreprocessorThread : public PreprocessorThread, public QThread
{
public:
  QtPreprocessorThread(Preprocessor *p, QObject *parent = 0);
  ~QtPreprocessorThread();
  
  void InitThread() {
	PreprocessorThread::InitThread();
  }
  void RunThread() {
	start(QThread::LowPriority);
  }

  // This function has to be defined by the thread library used...
  virtual int GetCurrentThreadId() const;

  
protected:
  void run() {
	Main();
  }
};

}
#endif
#endif
